﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;

namespace XamDataTreeIssue
{
   public class WorkingParentItem
   {
      ObservableCollection<ChildItem> m_oChildItems;

      public WorkingParentItem(string sName)
      {
         Name = sName;
      }

      public string Name { get; set; }

      public ObservableCollection<ChildItem> ChildItems
      {
         get
         {
            if (m_oChildItems == null)
               m_oChildItems = new ObservableCollection<ChildItem>();

            return m_oChildItems;
         }
      }
   }

   public class NonWorkingParentItem
   {
      ChildItems m_oChildItems;

      public NonWorkingParentItem(string sName)
      {
      }

      public string Name { get; set; }

      public ChildItems ChildItems
      {
         get
         {
            if (m_oChildItems == null)
               m_oChildItems = new ChildItems();

            return m_oChildItems;
         }
      }
   }

   public class ChildItem
   {
      public ChildItem(string sName)
      {
         Name = sName;
      }

      public string Name { get; set; }
   }

   public class NonWorkingParentItems : ObservableCollection<NonWorkingParentItem>, INotifyCollectionChanged, INotifyPropertyChanged
   {
   }

   public class ChildItems : ObservableCollection<ChildItem>
   {
   }
}
