﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace XamDataTreeIssue
{
   /// <summary>
   /// Interaction logic for MainWindow.xaml
   /// </summary>
   public partial class MainWindow : Window
   {
      ObservableCollection<WorkingParentItem>   m_oWorkingParentItems      = null;
      WorkingParentItem                         m_oWorkingParentItem       = null;
      NonWorkingParentItems                     m_oNonWorkingParentItems   = null;
      NonWorkingParentItem                      m_oNonWorkingParentItem    = null;

      public MainWindow()
      {
         InitializeComponent();
      }

      private void OnTestOne_Checked(object sender, RoutedEventArgs e)
      {
         try
         {
            if (m_wDerivedTest.IsChecked.GetValueOrDefault())
            {
               m_oNonWorkingParentItems = new NonWorkingParentItems();

               m_oNonWorkingParentItem = new NonWorkingParentItem("Parent 1");

               m_oNonWorkingParentItem.ChildItems.Add( new ChildItem("Child 1") );
               m_oNonWorkingParentItem.ChildItems.Add( new ChildItem("Child 2") );

               m_oNonWorkingParentItems.Add(m_oNonWorkingParentItem);

               m_wXamDataTree.ItemsSource = m_oNonWorkingParentItems;
            }
            else
            {
               m_oWorkingParentItems = new ObservableCollection<WorkingParentItem>();

               //m_oWorkingParentItem = new WorkingParentItem("Parent 1");

               //m_oWorkingParentItem.ChildItems.Add( new ChildItem("Child 1") );
               //m_oWorkingParentItem.ChildItems.Add( new ChildItem("Child 2") );

               //m_oWorkingParentItems.Add(m_oWorkingParentItem);

               m_wXamDataTree.ItemsSource = m_oWorkingParentItems;
            }
         }

         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }

      private void OnAddRootItem_Click(object sender, RoutedEventArgs e)
      {
         try
         {
            if (m_wDerivedTest.IsChecked.GetValueOrDefault())
            {
               m_oNonWorkingParentItems.Add(m_oNonWorkingParentItem = new NonWorkingParentItem("Parent Add 2"));
            }
            else
            {
               m_oWorkingParentItems.Add(m_oWorkingParentItem = new WorkingParentItem("Parent Add 2"));
            }
         }

         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }

      private void OnAddChildItem_Click(object sender, RoutedEventArgs e)
      {
         try
         {
            if (m_wDerivedTest.IsChecked.GetValueOrDefault())
            {
               m_oNonWorkingParentItem.ChildItems.Add(new ChildItem("Child Add 1"));
            }
            else
            {
               m_oWorkingParentItem.ChildItems.Add(new ChildItem("Child Add 1"));
            }
         }

         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }

      private void OnReset_Click(object sender, RoutedEventArgs e)
      {
         try
         {
            OnTestOne_Checked(sender, e);
         }

         catch (Exception ex)
         {
            MessageBox.Show(ex.Message);
         }
      }
   }
}
